<template>
  <div class="button" :class="action" @click="performAction">
    {{placeholder}}
  </div>
</template>

<script>
  export default {
    name: "actionTodoButton",
    props: ['action','id','placeholder','todo'],
    methods: {
      performAction () {
        let payload = {
          todo: this.todo,
          id: this.id
        }
        switch (this.action) {
          case 'edit': this.$router.push({name: 'single', params: { id: this.id}})
            break
          case 'remove': this.$emit('undo')
            break
          case 'revert': this.$emit('redo')
            break
          case 'cancel': this.$modal.show('confirm',{message: 'Are you sure you want to cancel all changes?',action: 'cancel'})
            break
          case 'add':
            this.$store.dispatch('saveTodo',payload)
            this.$router.push('/')
            break
          case 'delete':
            this.$modal.show('confirm',{message: 'Are you sure you want to delete this item?',action: 'delete', id: payload.id})
            break
          case 'delete-new':
            this.$modal.show('confirm',{message: 'Are you sure you want to delete this item?',action: 'delete-new', id: payload.id})
          break
        }
      }
    }
  }
</script>

<style scoped>
 .button {
   padding: 10px 15px;
 }
</style>